	@echo off
	rem -- Make for SNA Client App DLL
	rem -- Need to call with BLD set to base target directory
	rem -- Need to call with LEGOLIB set to special libs for lego build

	SetLocal

	set inc_samp=%include%
	set lib_samp=%lib%
	set INCLUDE=inc;%include%
	set LIB=inc;%lib%
	set DBCS=

	if "%BLD%" == "" set BLD=.
	set Intl=Intl\usa
	set Targets=all
	set MODE=none
	set ISVBUILD=ISVBUILD
	set ISVDIR=

:OptionLoop
	if "%1" == ""         goto CheckOptions

	if "%1" == "SHIP"     goto MakeShipVersion
	if "%1" == "ship"     goto MakeShipVersion
	if "%1" == "Ship"     goto MakeShipVersion
	if "%1" == "DEBUG"    goto MakeDebugVersion
	if "%1" == "debug"    goto MakeDebugVersion
	if "%1" == "Debug"    goto MakeDebugVersion
	if "%1" == "?"        goto Help
	if "%1" == "-?"       goto Help
	if "%1" == "/?"       goto Help
	if "%1" == "HELP"     goto Help
	if "%1" == "help"     goto Help
	if "%1" == "Help"     goto Help
	if "%1" == "clean"	  goto doClean
	if "%1" == "Clean"	  goto doClean
	if "%1" == "CLEAN"	  goto doClean

	goto Help

:MakeAll
	set MODE=All
	shift
	goto OptionLoop

:MakeShipVersion
	set MODE=Ship
	shift
	goto OptionLoop

:MakeDebugVersion
	set MODE=Debug
	shift
	goto OptionLoop

:CheckOptions
	set DEST=%BLD%\%MODE%
	set OUT=%BLD%\make.out
	set include=%include%;%Intl%
	echo International directory set to %Intl
	echo .
	if "%MODE%" == "Ship"    goto MakeIt
	if "%MODE%" == "Debug"   goto MakeIt
	if "%MODE%" == "CodeCov" goto MakeIt
	if "%MODE%" == "Lego"    goto MakeIt
	if "%MODE%" == "Bsc"     goto MakeBsc
	goto Help

:MakeBsc
	set MODE=Debug
	set DEST=%BLD%\%MODE%
	set UBROWSE=yes
	set Targets=%DEST%\setupcli.dll bsc

:MakeIt
	if not exist %DEST%\nul mkdir %DEST%
	%MAKETEE% nmake -f makefile -nologo %Targets%
	echo Making help files. . . 
	hcw /c/m/e setupcli.hpj
	hcw /c/m/e readme.hpj
	hcw /c/m/e snabase.hpj
	goto Exit

:DoMakeAll
	echo ***** Making ALL *****
	echo.
	echo ***** Making setupcli.Dll *****
	echo ***** Making setupcli.Dll *****

	if not exist %BLD%\Ship\nul		mkdir %BLD%\Ship
	if not exist %BLD%\Debug\nul	mkdir %BLD%\Debug
	if not exist %BLD%\Lego\nul	mkdir %BLD%\Lego

	nmake -f makefile -nologo MODE=Ship clean		
	nmake -f makefile -nologo MODE=Debug clean		
	nmake -f makefile -nologo MODE=Lego clean		

	%MAKETEE% nmake -f makefile -nologo MODE=Ship   
	%MAKETEE% nmake -f makefile -nologo MODE=Debug	
	set lib=%LEGOLIB%;%lib%
	%MAKETEE% nmake -f makefile -nologo MODE=Lego	

	goto Exit

:DoClean
	if "%MODE%" == "All"  goto CleanAll
	if "%MODE%" == "none" goto Help
	if "%MODE%" == "Bsc"  set MODE=Debug
	set DEST=%BLD%\%MODE%
	if not exist %DEST%\nul mkdir %DEST%
	nmake -f makefile -nologo clean
	goto Exit

:CleanAll
	if not exist %BLD%\Ship\nul    mkdir %BLD%\Ship
	if not exist %BLD%\Debug\nul   mkdir %BLD%\Debug
	if not exist %BLD%\CodeCov\nul mkdir %BLD%\CodeCov
	if not exist %BLD%\Lego\nul    mkdir %BLD%\Lego

	nmake -f makefile -nologo MODE=Ship    clean 
	nmake -f makefile -nologo MODE=Debug   clean 

	goto Exit

:Help
	echo     usage: 'make {ship^|debug}'
	echo          bsc:   implies debug
	echo          lego:  implies debug
	echo.
	echo      makes the Windows 95 SNA Client Setup Application
	echo	  Environment BLD -^> target directory, default ./Ship

:Exit
	set include=%inc_samp%
	set lib=%lib_samp%
	set inc_samp=
	set lib_samp=

	EndLocal

