/***************************************************************************
**
**	File:			SNACCAH.H
**	Purpose:		Sample application-specific DLL Custom
**					Action Handler routines for Acme Setup.
**	Notes:
**
****************************************************************************/

#include "setupapi.h"
#include "cui.h"
#include "stdtypes.h"
#include "setupkit.h"
#include "datadef.h"

#define STR_DETECT_TITLE "SNA Client for Windows 95"
#define STR_DETECT_MSG   "This product requires at least a 386 " \
			 "processor, a VGA display, and Microsoft Windows 95."

#define cpu8086  0
#define cpu80186 1
#define cpu80286 2

#define wmdStandard 1

/*
 * Detection Code Defines
 */
#define WINSOCKET_MAJOR 1
#define WINSOCKET_MINOR 1


typedef enum _WNC		/* File Needs Copying status */
	{
	wncHiVer,
	wncEqVer,
	wncLoVer,
	wncNoFile,
	wncUnknown
	}  WNC;

/*
 * Registry Entries to Add to the registry
 */
typedef enum _REGISTRYENTRIES
	{
	TransportRegistry,
	SponsorRegistry,
	SnaDomainRegistry,
	WindowsTypeRegistry,
	SnaVersionRegistry,
	InvalidRegistryEntry
	} REGISTRYENTRIES;

/*
 * Registry Parameter values for removing from the registry
 */
typedef enum _REGISTRYPARAMS
	{
	RegistryRemoveKey,
	RegistryRemoveSubKey,
	InvalidRegistryParam
	} REGISTRYPARAMS;

/*
 * Registry Entries to Remove from the registry
 */
typedef enum _REGISTRYREMOVEENTRIES
	{
	SystemSnaParameters,
	SystemSnaBase,
	SoftwareSetup,
	SoftwareCurrentVersion,
	SoftwareSnaServer,
	InvalidRemoveRegistryEntry
	} REGISTRYREMOVEENTRIES;

/*
 * Registry Information
 */
typedef enum _REGISTRYINFORMATION
	{
	RegistryKey,
	RegistryValue,
	RegistryData,
	InvalidRegistryInformation
	} REGISTRYINFORMATION;

/*
 * Popup Strings
 */
typedef enum _POPUPSTRINGS
	{
	WindowTitle,
	WindowMessage,
	InvalidPopupStrings
	} POPUPSTRINGS;

/* 
 * Error Defines
 */
typedef enum _ERRORTYPE
	{
	RegistrationError,
	ProtocolError,
	DomainNameError,
	PrimaryServerError,
	SnaBaseRunningError,
	SnaBaseComponentsRunningError,
	ODBCInstallationError,
	InvalidErrorType
	} ERRORTYPE;

/* 
 * Help Defines
 */
typedef enum _HELPTYPE
	{
	ClientModeHelp,
	ProtocolHelp,
	LocalClientHelp,
	RemoteClientHelp,
	InvalidHelpType
	} HELPTYPE;

/*
 * Function Prototypes
 */

RC FAR PASCAL DetectMinimumHardware ( PCD pcd, POD pod, CAMF camf,
				      PCAMFD pcamfd, SZ szData );
RC FAR PASCAL SetClientParameters ( PCD pcd, POD pod, CAMF camf,
				    PCAMFD pcamfd, SZ szData );
RC FAR PASCAL CountInstalledApps ( PCD pcd, POD pod, CAMF camf,
				   PCAMFD pcamfd, SZ szData );
#ifndef ISVBUILD
RC FAR PASCAL InstallODBCFiles ( PCD pcd, POD pod, CAMF camf,
				   PCAMFD pcamfd, SZ szData );
#endif
void initDlgPosWnd(HWND hDlg);

void DisplayError( ERRORTYPE ErrorIndex);

void DisplayHelp( HELPTYPE HelpIndex);

BOOL CALLBACK ExitYesNoDlg( HWND hDlg, UINT message,
    			    WPARAM wParam, LPARAM lParam);

void ExitYesNoMB(void);

int AddRegistryEntry ( LPSTR RegistryKey,
                       LPSTR RegistryName,
                       LPSTR RegistryData );

int UpdateRegistry(void);

void RemoveRegistry(void);

BOOL SetupSystemParameters(PCD pcd, POD pod, CAMF camf,
			   PCAMFD pcamfd, SZ szData ); 

void GetInstalledProtocols( BOOL *MSFT_protocol, 
			    BOOL *NOVELL_protocol, 
			    BOOL *TCPIP_protocol);

BOOL CALLBACK ClientProtocolsDlg( HWND hDlg, UINT message,
    				  WPARAM wParam, LPARAM lParam);

BOOL CALLBACK RemoteClientDlg( HWND hDlg, UINT message,
			       WPARAM wParam, LPARAM lParam);

BOOL CALLBACK LocalClientDlg( HWND hDlg, UINT message,
 			      WPARAM wParam, LPARAM lParam);

BOOL CALLBACK ClientModeDlg( HWND hDlg, UINT message,
			     WPARAM wParam, LPARAM lParam);

void CreateInvisibleWindow(void);

void DestroyInvisibleWindow(void);